# $Revision: 1.19 $, $Date: 2011/11/17 19:53:22 $
# TODO
# - cmake is borken and adds objects (static libs) in the middle of lists (Renderer/libRenderer.a):
#   Linking CXX shared library libprojectM.so
#   /usr/bin/cmake -E cmake_link_script CMakeFiles/projectM-shared.dir/link.txt --verbose=1
#   /usr/bin/ccache  i686-pld-linux-g++ -fPIC -O2 -fno-strict-aliasing -fwrapv -march=i686 -mtune=pentium4 -gdwarf-3 -g2   -fopenmp  -Wl,--as-needed -Wl,--no-copy-dt-needed-entries -Wl,-z,relro -Wl,-z,combreloc  -shared -Wl,-soname,libprojectM.so.2 -o libprojectM.so.2.0.1 CMakeFiles/projectM-shared.dir/projectM.cpp.o CMakeFiles/projectM-shared.dir/PCM.cpp.o CMakeFiles/projectM-shared.dir/Preset.cpp.o CMakeFiles/projectM-shared.dir/fftsg.cpp.o CMakeFiles/projectM-shared.dir/KeyHandler.cpp.o CMakeFiles/projectM-shared.dir/timer.cpp.o CMakeFiles/projectM-shared.dir/wipemalloc.cpp.o CMakeFiles/projectM-shared.dir/PresetLoader.cpp.o CMakeFiles/projectM-shared.dir/PresetChooser.cpp.o CMakeFiles/projectM-shared.dir/PipelineMerger.cpp.o CMakeFiles/projectM-shared.dir/ConfigFile.cpp.o CMakeFiles/projectM-shared.dir/TimeKeeper.cpp.o CMakeFiles/projectM-shared.dir/PresetFactory.cpp.o CMakeFiles/projectM-shared.dir/PresetFactoryManager.cpp.o Renderer/libRenderer.a NativePresetFactory/libNativePresetFactory.a MilkdropPresetFactory/libMilkdropPresetFactory.a -lGLEW -lftgl -lfreetype -lGLU -lGL -lSM -lICE -lX11 -lXext Renderer/libRenderer.a -lm
#
#   CMakeLists.txt having:
#   TARGET_LINK_LIBRARIES(projectM-shared ${PRESET_FACTORY_LINK_TARGETS} ${GLEW_LINK_TARGETS} m dl ${FTGL_LINK_TARGETS} ${OPENGL_LIBRARIES}  ${IMAGE_LINK_TARGETS} ${CG_LINK_TARGETS})
#
#   NativePresetFactory/CMakeLists.txt has:
#   TARGET_LINK_LIBRARIES(NativePresetFactory Renderer m)
#   which mixes .a between -l for dl

%define		pkgname	projectM
Summary:	Awesome music visualizer
Summary(pl.UTF-8):	Imponujący wizualizator muzyki
Name:		libprojectM
Version:	2.0.1
Release:	6
Epoch:		1
License:	LGPL
Group:		Libraries
Source0:	http://downloads.sourceforge.net/project/projectm/%{version}/projectM-%{version}-Source.tar.gz
# Source0-md5:	f8bf795878cdbbef54784cf2390b4c89
Patch0:		%{name}-soname.patch
Patch1:		%{name}-fonts.patch
Patch2:		%{name}-static.patch
Patch3:		as-needed.patch
Patch4:		%{name}-pkgconfig.patch
Patch5:		01-change-texture-size.patch
Patch6:		04-change-preset-duration.patch
Patch7:		06-fix-numeric-locale.patch
URL:		http://projectm.sourceforge.net/
BuildRequires:	cmake
BuildRequires:	ftgl-devel >= 2.1.3
BuildRequires:	glew-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.577
BuildRequires:	sed >= 4.0
Requires:	fonts-TTF-bitstream-vera
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# cmake (or cmake rules) are broken, mixes .a (objects) with libs (-l)
%define		filterout_ld	-Wl,--as-needed

%description
projectM is a reimplementation of Milkdrop under OpenGL. It is an
awesome music visualizer. There is nothing better in the world of
Unix.

%description -l pl.UTF-8
projectM jest reimplementacją projektu Milkdrop na OpenGL. Jest
imponującym wizualizatorem muzyki. Nie ma nic lepszego w świecie
uniksa.

%package devel
Summary:	Header files for projectM library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki projectM
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
Header files for projectM library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki projectM.

%package static
Summary:	Static projectM library
Summary(pl.UTF-8):	Statyczna biblioteka projectM
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static projectM library.

%description static -l pl.UTF-8
Statyczna biblioteka projectM.

%prep
%setup -q -n projectM-%{version}-Source
%undos config.inp.in
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4	-p1
%patch5	-p0
%patch6	-p0
%patch7	-p0

%build
install -d build
cd build
%cmake \
	-DCMAKE_LIB_DIR=%{_libdir} \
	-DBUILD_PROJECTM_STATIC=yes \
	../
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc ChangeLog
%attr(755,root,root) %{_libdir}/libprojectM.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libprojectM.so.2
%dir %{_datadir}/%{pkgname}
%{_datadir}/%{pkgname}/config.inp
%dir %{_datadir}/%{pkgname}/presets
%{_datadir}/%{pkgname}/presets/*.milk
%{_datadir}/%{pkgname}/presets/*.prjm
%{_datadir}/%{pkgname}/presets/*.tga
%dir %{_datadir}/%{pkgname}/shaders
%{_datadir}/%{pkgname}/shaders/*.cg

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libprojectM.so
%{_includedir}/%{name}
%{_pkgconfigdir}/libprojectM.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libprojectM.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: libprojectM.spec,v $
Revision 1.19  2011/11/17 19:53:22  arekm
- release 6

Revision 1.18  2011/08/31 07:34:51  arekm
- release 5

Revision 1.17  2010/09/06 11:13:50  glen
- add patches from clementine 0.5; rel 4

Revision 1.16  2010/07/08 14:44:17  lisu
- force pkgconfig to use -L/usr/lib or -L/usr/lib64 (avoid situations when pkg-config --libs libprojectM returns "-L-libprojectM")
- rel 3

Revision 1.15  2010/07/07 07:21:33  glen
- cmake as needed broken, disable; rel 2

Revision 1.14  2010/07/07 06:32:33  glen
- up to 2.0.1

Revision 1.13  2010/02/27 21:11:19  sparky
- unify %attr() %ghost order

Revision 1.12  2009/09/22 06:37:50  adamg
- updated to 1.2.0

Revision 1.11  2008/08/27 22:18:09  glen
- release 3 (libGLEW soname)

Revision 1.10  2008/08/05 10:20:03  hawk
- release 2

Revision 1.9  2008-04-01 20:43:39  arvenil
- added epoch to R: in subpackages

Revision 1.8  2008-03-31 21:07:01  arvenil
- Epoch: 1 (1.1 == 1.01)

Revision 1.7  2008-03-31 20:26:29  arvenil
- up to 1.1
- more verbose preset files

Revision 1.6  2007-10-12 14:00:18  arvenil
- up to 1.01

Revision 1.5  2007/10/12 13:51:51  arvenil
- s/%description -p/%description -l/
- adapter

Revision 1.4  2007/10/12 11:05:04  beorn
- PL desc
- Tested, works. Full release.

Revision 1.3  2007/10/11 20:29:51  arvenil
- up to 1.0
- patch for build static library
- builds but not tested if it works

Revision 1.2  2007/10/01 22:30:54  arvenil
- new URL

Revision 1.1  2007/09/14 16:08:57  arvenil
- init
